#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>
#include <map>

#include "testlib.h"

using namespace std;

int StartId = 100;

void p(int k, const vector<int> & a) {
    static int id = StartId;
    static char filename[10];

    sprintf(filename, "%d", id);
    ++id;
    FILE * fout = fopen(filename, "wt");
    fprintf(fout, "%d\n", k);
    for (size_t i = 0; i < a.size(); ++i) {
        if (i > 0) {
            fprintf(fout, " ");
        }
        fprintf(fout, "%d", a[i]);
    }
    fprintf(fout, "\n");
    fclose(fout);
}

void GenRandom(int k, int amax, int amin = 0)
{
    vector<int> a(k);
    for (size_t i = 0; i < k; ++i) {
        a[i] = rnd.next(amin, amax);
    }
    p(k, a);
}

int main(int argc, char * argv[])
{
    registerGen(argc, argv);
    StartId = atoi(argv[1]);
    int gen2nd = atoi(argv[2]);
    int gen3rd = atoi(argv[3]);

    if (gen2nd) {
        const int testCnt = 5;
        const int testK[testCnt] = {
            3,
            5,
            8,
            9,
            10
        };

        for (int id = 0; id < testCnt - 1; ++id) {
            GenRandom(testK[id], 10);
        }

        GenRandom(testK[testCnt - 1], 0, 0); /// all zeroes
    }

    if (gen3rd) {
        const int testCnt = 5;
        const int testK[testCnt] = {
            40,
            50,
            100,
            500,
            1000
        };

        for (int id = 0; id < testCnt - 1; ++id) {
            GenRandom(testK[id], 1000);
        }

        GenRandom(testK[testCnt - 1], 1000, 1000); /// max test
    }

    return 0;
}
