#include <cstdio>

#include "valuer.h"

using namespace NValuer;

int main()
{
    TValuer valuer(TValuer::FullScore, 60);
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 1, 2, 0));
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 3, 7, 30));
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 8, 12, 30));
    valuer.Add(TestGroup(TestGroup::ClassicScore, 13, 17, 40), TValuer::Offline);
    if (!valuer.Ok(100)) {
        return 43;
    }

    TEjudgeCheckResultParser parser;
    int score = valuer.CalcScore(parser);
    printf("%d\n", score);

    return 0;
}
